//go:build !fasthttp
// +build !fasthttp

package jwtmdl

import (
	"net/http"

	jwt "github.com/golang-jwt/jwt/v5"
	"github.com/golang-jwt/jwt/v5/request"
)

// DecodeTokenWithJWTKey decode token
func DecodeTokenWithJWTKey(req *http.Request, jwtKey string) (jwt.MapClaims, error) {
	return decode(request.ParseFromRequest(req, request.OAuth2Extractor, keyFunc(jwtKey)))
}

// DecodeToken decode token
func DecodeToken(req *http.Request) (jwt.MapClaims, error) {
	return DecodeTokenWithJWTKey(req, GlobalJWTKey)
}
