package roleenforcemdl

import (
	"fmt"
	"net/http"
	"testing"

	"corelab.mkcl.org/MKCLOS/coredevelopmentplatform/corepkgv2/authmdl/jwtmdl"

	"github.com/stretchr/testify/assert"
)

func TestLoadRoleConfiguration(t *testing.T) {
	LoadRoleConfiguration("../../testingdata/roleenforcer/rolemapping.csv")
	fmt.Println(roleManagementConfig)
}

// func TestEnforce(t *testing.T) {
// 	LoadRoleConfiguration("../../testingdata/roleenforcer/rolemapping.csv")
// 	boolVal := Enforce("checkstatus", "Bearer eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJJZCI6InNhbmRlZXBzcyIsImdyb3VwcyI6WyJhZG1pbiIsInRlYWNoZXIiXX0.Bx0KWD7Q5joxoFcODy5xRdkO7NuHGD0tJFH4PUBlOjA", "mysupersecretpassword", "groups")
// 	fmt.Println("boolVal : ", boolVal)
// }

func Test_checkAccess(t *testing.T) {
	LoadRoleConfiguration("../../testingdata/roleenforcer/rolemapping.csv")
	groupList := []string{"admin"}
	rs := checkAccess("login", groupList)
	assert.True(t, rs)

	groupList = []string{"admin"}
	rs = checkAccess("something", groupList)
	assert.True(t, rs)

	groupList = []string{"teacher"}
	rs = checkAccess("checkstatus", groupList)
	assert.False(t, rs)

	groupList = []string{"admin"}
	rs = checkAccess("checkstatus", groupList)
	assert.True(t, rs)

	groupList = []string{"teacher"}
	rs = checkAccess("something", groupList)
	assert.False(t, rs)

	groupList = []string{"teacher"}
	rs = checkAccess("login", groupList)
	assert.False(t, rs)
}

func TestDecodeTokenvalid(t *testing.T) {
	req, _ := http.NewRequest("POST", "/r/c/mql", nil)
	req.Header.Set("Authorization", "Bearer eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJJZCI6InNhbmRlZXBzcyIsImdyb3VwIjpbImFkbWluIl19.dGSKQZMGSEBjgPrjTHJwylcxIxxMKylahuFn7DHR4pc")
	claims, derror := jwtmdl.DecodeTokenWithJWTKey(req, "mysupersecretpassword")
	fmt.Println(claims)
	GetGroupNames(claims, "group")
	assert.NoError(t, derror, "No error occured")

}
