package locker

import (
	"sync"
)

var mutexMap = map[string]*sync.Mutex{}
var getMapSyncMutex = &sync.Mutex{}

func NewLocker(filePath string) *FileLocker {
	getMapSyncMutex.Lock()
	defer getMapSyncMutex.Unlock()
	m, found := mutexMap[filePath]
	if !found {
		m = &sync.Mutex{}
		mutexMap[filePath] = m
	}
	locker := FileLocker{
		m,
		filePath,
	}
	return &locker
}

type Locker interface {
	Lock()
	Unlock()
}

type FileLocker struct {
	Locker
	LockOn string
}

func (l *FileLocker) Lock() {
	l.Locker.Lock()
}
func (l *FileLocker) Unlock() {
	l.Locker.Unlock()
}
