package lazywriter

import (
	"fmt"
	"strconv"
	"sync"
	"testing"

	"github.com/tidwall/gjson"

	"github.com/noaway/heartbeat"
)

var masterLazzyObj LazyFDBHelper

func init() {
	masterLazzyObj.StartProcessForAppend(10000, "append", 100, 5, 5, false)
}

func TestStartProcess(t *testing.T) {

	task, _ := heartbeat.NewTast("Sample", 3)
	startIndex := 0
	wg := sync.WaitGroup{}
	wg.Add(1)

	task.Start(func() error {
		lazyCacheObject := LazyCacheObject{}
		lazyCacheObject.FileName = "logs.json"
		lazyCacheObject.Identifier = "logs.json"
		startIndex += 3
		tmp := `{"name":"SampleObject", "timeInterval": "` + strconv.Itoa(startIndex) + `"}`
		lazyCacheObject.GJSONData = gjson.Parse(tmp)
		if ok := masterLazzyObj.SaveOrUpdateDataInCache(lazyCacheObject); ok {
			fmt.Println("Object append")
		} else {
			fmt.Println("Object not append")
		}
		return nil
	})
	wg.Wait()
}
