//@author  Ajit Jagtap
//@version Thu Jul 05 2018 06:36:54 GMT+0530 (IST)

// Package errormdl will help you catch error
package errormdl

import (
	"fmt"

	"corelab.mkcl.org/MKCLOS/coredevelopmentplatform/corepkgv2/constantmdl"
)

// IsTestingNegetiveCaseOn mark this on if you want system cases to fail
var IsTestingNegetiveCaseOnCheckBool bool
var IsTestingNegetiveCaseOnCheckBool1 bool
var IsTestingNegetiveCaseOnCheckBool2 bool
var IsTestingNegetiveCaseOnCheckBool3 bool

// IsTestingNegetiveCaseOn mark this on if you want system cases to fail
var IsTestingNegetiveCaseOnCheckInt bool
var IsTestingNegetiveCaseOnCheckInt1 bool
var IsTestingNegetiveCaseOnCheckInt2 bool

// IsTestingNegetiveCaseOn mark this on if you want system cases to fail
var IsTestingNegetiveCaseOn bool

// IsTestingNegetiveCaseOn1 mark this on if you want system cases to fail
var IsTestingNegetiveCaseOn1 bool

// IsTestingNegetiveCaseOn2 mark this on if you want system cases to fail
var IsTestingNegetiveCaseOn2 bool

// IsTestingNegetiveCaseOn3 mark this on if you want system cases to fail
var IsTestingNegetiveCaseOn3 bool

// CoreError is custom error
type CoreError struct {
	msg string
}

// CheckBool will help checking bool condition for real as well as test cases. It can fail based on  IsTestingNegetiveCaseOn flag
func CheckBool(orginalInput bool) bool {
	if IsTestingNegetiveCaseOnCheckBool {
		return !orginalInput
	}
	return orginalInput

}

func CheckBool1(orginalInput bool) bool {
	if IsTestingNegetiveCaseOnCheckBool1 {
		return !orginalInput
	}
	return orginalInput
}
func CheckBool2(orginalInput bool) bool {
	if IsTestingNegetiveCaseOnCheckBool2 {
		return !orginalInput
	}
	return orginalInput
}

func CheckBool3(orginalInput bool) bool {
	if IsTestingNegetiveCaseOnCheckBool3 {
		return !orginalInput
	}
	return orginalInput
}

// CheckInt will help checking int condition for real as well as test cases. It can fail based on  IsTestingNegetiveCaseOn flag
func CheckInt(len int) int {
	if IsTestingNegetiveCaseOnCheckInt {
		return constantmdl.ZERO
	}
	return len
}
func CheckInt1(len int) int {
	if IsTestingNegetiveCaseOnCheckInt1 {
		return constantmdl.MINUS_ONE
	}
	return len
}
func CheckInt2(len int) int {
	if IsTestingNegetiveCaseOnCheckInt2 {
		return constantmdl.MINUS_ONE
	}
	return len
}

// CheckErr will help checking err condition for real as well as test cases. It can fail based on  IsTestingNegetiveCaseOn flag
func CheckErr(err error) error {
	if IsTestingNegetiveCaseOn {
		return Wrap("This is test error")
	}
	return err
}

// CheckErr1 condition for real as well as test cases. It can fail based on  IsTestingNegetiveCaseOn1 flag
func CheckErr1(err error) error {
	if IsTestingNegetiveCaseOn1 {
		return Wrap("This is test error")
	}
	return err
}

// CheckErr2 condition for real as well as test cases. It can fail based on  IsTestingNegetiveCaseOn2 flag
func CheckErr2(err error) error {
	if IsTestingNegetiveCaseOn2 {
		return Wrap("This is test error")
	}
	return err
}

// CheckErr3 condition for real as well as test cases. It can fail based on  IsTestingNegetiveCaseOn3 flag
func CheckErr3(err error) error {
	if IsTestingNegetiveCaseOn3 {
		return Wrap("This is test error")
	}
	return err
}

// Wrap Use wrapper error an not golang
func Wrap(msg string) *CoreError {
	err := CoreError{}
	err.msg = msg
	return &err
}

// WrapWithCode Use wrapper error an not golang
func WrapWithCode(msg string, errorCode int) (int, *CoreError) {
	err := CoreError{}
	err.msg = msg
	return errorCode, &err
}

// Error is interface method so that this will help compatibility with error
func (cerr *CoreError) Error() string {
	return fmt.Sprintf(cerr.msg)
}
