//@author  Ajit Jagtap
//@version Thu Jul 05 2018 06:36:43 GMT+0530 (IST)
package errormdl

import (
	"errors"
	"testing"

	"github.com/stretchr/testify/assert"
)

func TestCoreError_Wrap(t *testing.T) {
	err := Wrap("test")
	if err != nil {
		assert.Len(t, err.Error(), 4, "Check if we get back error")
		assert.Error(t, err)
	}
}

func TestCheckBool(t *testing.T) {
	IsTestingNegetiveCaseOnCheckBool = true
	assert.False(t, CheckBool(true), "it should return true")
	IsTestingNegetiveCaseOnCheckBool = false
	assert.False(t, CheckBool(false), "it should return false")

	IsTestingNegetiveCaseOnCheckBool1 = true
	assert.False(t, CheckBool1(true), "it should return true")
	IsTestingNegetiveCaseOnCheckBool1 = false
	assert.False(t, CheckBool1(false), "it should return false")

	IsTestingNegetiveCaseOnCheckBool2 = true
	assert.False(t, CheckBool2(true), "it should return true")
	IsTestingNegetiveCaseOnCheckBool2 = false
	assert.False(t, CheckBool2(false), "it should return false")

	IsTestingNegetiveCaseOnCheckBool3 = true
	assert.False(t, CheckBool3(true), "it should return true")
	IsTestingNegetiveCaseOnCheckBool3 = false
	assert.False(t, CheckBool3(false), "it should return false")
}

func TestCheckError(t *testing.T) {
	IsTestingNegetiveCaseOn = false
	assert.Error(t, CheckErr(errors.New("hi")))
	IsTestingNegetiveCaseOn = true
	assert.Error(t, CheckErr(errors.New("hi")))
}

func TestCheckError1(t *testing.T) {
	IsTestingNegetiveCaseOn1 = false
	assert.Error(t, CheckErr1(errors.New("hi")))
	IsTestingNegetiveCaseOn1 = true
	assert.Error(t, CheckErr1(errors.New("hi")))
}

func TestCheckError2(t *testing.T) {
	IsTestingNegetiveCaseOn2 = false
	assert.Error(t, CheckErr2(errors.New("hi")))
	IsTestingNegetiveCaseOn2 = true
	assert.Error(t, CheckErr2(errors.New("hi")))
}

func TestCheckError3(t *testing.T) {
	IsTestingNegetiveCaseOn3 = false
	assert.Error(t, CheckErr3(errors.New("hi")))
	IsTestingNegetiveCaseOn3 = true
	assert.Error(t, CheckErr3(errors.New("hi")))
}
func TestCheckInt(t *testing.T) {
	IsTestingNegetiveCaseOnCheckInt = false
	assert.Equal(t, CheckInt(2), 2, "Should return 2")
	IsTestingNegetiveCaseOnCheckInt = true
	assert.Equal(t, CheckInt(2), 0, "Should return zero")
}

func TestCheckInt1(t *testing.T) {
	IsTestingNegetiveCaseOnCheckInt1 = false
	assert.Equal(t, CheckInt1(2), 2, "Should return 2")
	IsTestingNegetiveCaseOnCheckInt1 = true
	assert.Equal(t, CheckInt1(2), -1, "Should return -1")
}

func TestCheckInt2(t *testing.T) {
	IsTestingNegetiveCaseOnCheckInt2 = false
	assert.Equal(t, CheckInt2(2), 2, "Should return 2")
	IsTestingNegetiveCaseOnCheckInt2 = true
	assert.Equal(t, CheckInt2(2), -1, "Should return -1")
}
