package sms

import (
	"testing"

	"corelab.mkcl.org/MKCLOS/coredevelopmentplatform/corepkgv2/errormdl"
	"github.com/stretchr/testify/assert"
)

func TestInit(t *testing.T) {
	errormdl.IsTestingNegetiveCaseOn = true
	err := Init("sms-config.toml")
	errormdl.IsTestingNegetiveCaseOn = false
	assert.NoError(t, err, "This should not return error")
}

func TestSendSMS(t *testing.T) {
	Init("sms-config.toml")
	err := SendSMS("Hi..", "7768982288")
	assert.NoError(t, err, "This should not return error")
}

func TestSendMobileempty(t *testing.T) {
	Init("sms-config.toml")
	err := SendSMS("Hi..", "")
	assert.Error(t, err, "This should return error")
}

func TestSendMessageempty(t *testing.T) {
	Init("sms-config.toml")
	err := SendSMS("", "7768982288")
	assert.NoError(t, err, "This should not return error")
}
func TestSendSMSError(t *testing.T) {
	errormdl.IsTestingNegetiveCaseOn = true
	Init("sms-config.toml")
	err := SendSMS("Hi..", "7768982288")
	errormdl.IsTestingNegetiveCaseOn = false
	assert.NoError(t, err, "This should return error")
}

func TestSendSMSError1(t *testing.T) {
	errormdl.IsTestingNegetiveCaseOn1 = true
	Init("sms-config.toml")
	err := SendSMS("Hi..", "7768982288")
	errormdl.IsTestingNegetiveCaseOn1 = false
	assert.NoError(t, err, "This should not return error")
}
