package sjsonhelpermdl

import (
	"encoding/json"
	"fmt"
	"testing"
	"time"

	"github.com/tidwall/gjson"

	"github.com/stretchr/testify/assert"
)

func TestSetMultiple(t *testing.T) {
	input := ""
	keys := []string{"name", "age", "time"}
	values := []interface{}{"abc", 23, time.Now()}
	output, setError := SetMultiple(input, keys, values)
	fmt.Println(output)
	assert.NoError(t, setError)

}

func TestSetinGJSON(t *testing.T) {
	input := gjson.Parse("")
	keys := []string{"name", "age", "time"}
	values := []interface{}{"abc", 23, time.Now()}
	output, setError := SetInGJSON(input, keys, values)
	fmt.Println(output.Value())
	assert.NoError(t, setError)

}

func BenchmarkSetinGJSON(b *testing.B) {
	for index := 0; index < b.N; index++ {
		input := gjson.Parse("")
		keys := []string{"name.sub.sub1", "age"}
		values := []interface{}{"abc", 23}
		SetInGJSON(input, keys, values)
	}
}

func BenchmarkTest(b *testing.B) {
	for i := 0; i < b.N; i++ {
		tmpStr := struct {
			Name struct {
				Sub struct {
					Sub1 string `json:"sub1"`
				}
			}
			Age int `json:"age"`
		}{}
		tmp := "{}"
		// tmp := `{"name":"roshan", "age": 23}`
		json.Unmarshal([]byte(tmp), &tmpStr)
		tmpStr.Name.Sub.Sub1 = "abc"
		tmpStr.Age = 23
		json.Marshal(tmpStr)
	}
}
