//@author  Ajit Jagtap
//@version Thu Jul 05 2018 10:02:40 GMT+0530 (IST)

// Package stringmdl will help you to play with strings
package stringmdl

import (
	"encoding/base64"

	"corelab.mkcl.org/MKCLOS/coredevelopmentplatform/corepkgv2/errormdl"
	"github.com/lithammer/fuzzysearch/fuzzy"
)

// FuzzyFind will find string in array
func FuzzyFind(find string, arr *[]string) []string {
	return fuzzy.Find(find, *arr)
}

// FuzzyRankFind will find rank of string in array
func FuzzyRankFind(find string, arr *[]string) []fuzzy.Rank {
	return fuzzy.RankFind(find, *arr)
}

// This function is failing FuzzyRankMatch will find rank of string other string
// func FuzzyRankMatch(find, str string) int {
// 	return fuzzy.RankMatch(find, str)
// }

// ConvertStringToBase64 will Convert String To Base64
func ConvertStringToBase64(str string) string {
	encoded := base64.StdEncoding.EncodeToString([]byte(str))
	return encoded
}

// ConvertBase64ToString will Convert Base64 To String
func ConvertBase64ToString(basestr string) (string, error) {
	conStr, err := base64.StdEncoding.DecodeString(basestr)
	return string(conStr), errormdl.CheckErr(err)
}
