package stringmdl

import (
	"testing"

	_ "github.com/lithammer/fuzzysearch/fuzzy"
	"github.com/stretchr/testify/assert"
)

func TestConvertBase64(t *testing.T) {
	somestring := "some string"
	base64 := ConvertStringToBase64(somestring)
	base64New, err := ConvertBase64ToString(base64)
	assert.NoError(t, err, "It Should not gen error")
	assert.Equal(t, somestring, base64New, "Orginal string and converted string should be same. ")
}

func TestStringTesting(t *testing.T) {
	//Find In String
	arr := []string{"This is new string", "and str", "something which should not find"}
	findResult := FuzzyFind("str", &arr)
	assert.Len(t, findResult, 2, "it should find str")

	result := FuzzyRankFind("str", &arr)
	assert.Len(t, result, 2, "This should find count of match")

	//matchcnt := FuzzyRankMatch("kitten", "sitting")
	//assert.Equal(t, 3, matchcnt, "Match count should be same")
}
