package workerpoolmdl

import (
	"fmt"
	"sync"
	"testing"

	"github.com/stretchr/testify/assert"
)

var globalvar int
var mutex = &sync.Mutex{}

func TestWorkerPool(t *testing.T) {
	globalvar = 0
	// HOW TO USE IT
	fn := func(data interface{}) error {
		mutex.Lock()
		globalvar++
		mutex.Unlock()

		return nil
	}

	tasks := []*Task{}

	for index := 0; index < 100; index++ {
		tasks = append(tasks, NewTask(index, fn))
	}

	p := NewPool(tasks, 100)
	p.Run()

	var numErrors int
	for _, task := range p.Tasks {
		if task.Err != nil {
			fmt.Println(task.Err)
			numErrors++
		}
		if numErrors >= 10 {
			fmt.Println("Too many errors.")
			break
		}
	}

	assert.Equal(t, 100, globalvar, "Count should match")

}
